package src;
import java.io.File; 
import java.util.*; 
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.filechooser.*;
import java.beans.*;
import java.text.*;


public class FilePreview extends JPanel implements PropertyChangeListener{
	private JFileChooser chooser;
	private JLabel name, size, date, icon, description;

	public FilePreview(JFileChooser chooser){
		super(new GridLayout(0,1));	
		
		add(icon = new JLabel("Icono del fichero"));
		add(description = new JLabel("Descripcin del fichero"));
		add(name = new JLabel("Nombre del fichero"));
		add(size = new JLabel("Tamao del fichero"));
		add(date = new JLabel("Fecha ltima modificacin"));
		
		this.chooser = chooser;
		this.chooser.addPropertyChangeListener(this);
		setBorder(new TitledBorder("Preview"));
	}

	public void propertyChange(PropertyChangeEvent e) {
		String prop = e.getPropertyName();
		
		if(JFileChooser.SELECTED_FILE_CHANGED_PROPERTY.equals(prop)){
			
			File file = (File) e.getNewValue();
			if(file == null){
				clear();
				return;	
			}
			
			FileSystemView vueSysteme = FileSystemView.getFileSystemView(); 
			Locale locale = Locale.getDefault();
			NumberFormat nf = NumberFormat.getInstance(locale);
			DateFormat dateFormat = DateFormat.getDateInstance(DateFormat.SHORT, locale);
			
			icon.setIcon(vueSysteme.getSystemIcon(file));
			
			name.setText(vueSysteme.getSystemDisplayName(file));
			
			description.setText(vueSysteme.getSystemTypeDescription(file));
			
			String sizeFile = nf.format(file.length()/1024.0)+" Kb";
			size.setText(sizeFile);
			
			String dateFile = dateFormat.format(new Date(file.lastModified()));
			date.setText("Fecha lt. mod. : "+dateFile);
			
		}else{
			clear();	
		}
	}

	private void clear(){
		icon.setIcon(null);
		name.setText("Nombre fichero");	
		description.setText("Descripcin fichero");
		size.setText("Tamao fichero");	
		date.setText("ltima modificacin del fichero");
	}

	//Test
	public static void main(String[] args){
		JFileChooser chooser = new JFileChooser(".");
		chooser.setAccessory(new FilePreview(chooser));
		chooser.showOpenDialog(null);
	}
}