package src;

import java.*;
import java.awt.*;
import java.lang.*;
import java.io.Serializable;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.OneToMany;
import javax.persistence.OneToOne;
import javax.persistence.Persistence;

@Entity
public class Jugador extends Propiedades implements Serializable
{

    
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    @Column(name="JugadorId")
    private Long id;
    
    
    private boolean enCarcel;

    private boolean estaEnBancarrota;
    
    
    
    private int dinero;
    
    private int numcasilla = 0;
    
//    @Column(name="NombreJugador")
    private String nombre="";
    

    private String TipoFicha="uno";
    
  
  //  private Propiedades prop;
    
    private int numeroPropiedades;
    
    private int[] monopolios= new int[8];      //marron,celeste,rosa,naranja,rojo,amarillo,verde,azul            
    private int monopo;        
    public Jugador() 
    {
       
       super(0,0,"",0,0);
    
       this.dinero = 1500;
//       prop = new Propiedades(0,0,"",0,0);
       this.numeroPropiedades=0;
       for(int i=0;i<=7;i++)
           monopolios[i]=0;
      monopo=0;
       estaEnBancarrota=false;
   
        
    }
    
    
    @Override
    public String toString() {
    
        return  " (" +id+ ")  \tnumCasilla: " +numcasilla+ "\tnombre:" + nombre + "\tbancarrota: "+ estaEnBancarrota+ "\tFicha:"+TipoFicha+ "\ten carcel: " +enCarcel +"\tpropiedades: "+numeroPropiedades+ "\tdinero: " +dinero+ "\tmonopolios: "+monopo+"";
       
    }
    
    
    
    /**** metodo en prueba ****/    
    //Posicion del jugador respecto del tablero
	public static int[][] placement_jug1 = {
		
		{ 572, 572 }, //go
		{ 488, 572 },
		{ 440, 572 },
		{ 390, 572 },
		{ 343, 572 },
		{ 292, 572 },
		{ 240, 572 },
		{ 193, 572 },
		{ 146, 572 },
		{ 99, 572 },
		{ 11, 572 },
		{ 11, 486 },
		{ 11, 436 },
		{ 11, 386 },
		{ 11, 338 },
		{ 11, 290 },
		{ 11, 240 },
		{ 11, 192 },
		{ 11, 144 },
		{ 11, 96 },
		{ 11, 11 },
		{ 99, 11 },
		{ 146, 11 },
		{ 193, 11 },
		{ 240, 11 },
		{ 292, 11 },
		{ 343, 11 },
		{ 390, 11 },
		{ 440, 11 },
		{ 488, 11 },
		{ 572, 11 },
		{ 572, 96 },
		{ 572, 144 },
		{ 572, 192 },
		{ 572, 240 },
		{ 572, 290 },
		{ 572, 338 },
		{ 572, 386 },
		{ 572, 436 },
		{ 572, 486 }
		};
    
    /******************************/
            

    public boolean getEnCarcel() {
        return enCarcel;
    }

    public void setEnCarcel(boolean val) {
        this.enCarcel = val;
    }
    
    public void incMonopolios(int ind)
    {
          monopolios[ind]++;
    }
    
    public void incNumProp(){
        this.numeroPropiedades++;
    }
    
     public void decNumProp(){
        this.numeroPropiedades--;
    }
    /* 
     * devuelve el numero de propiedades
     */
    
    public int getNumProp(){
        return this.numeroPropiedades;
    }

    public int getDinero() {
        return dinero;
    }
    
    public int getNumcasilla()
    {
        return numcasilla;
    }
    
    public void setNumCasilla(int val)
    {
        this.numcasilla=val;
    }
 
  
    
    public void setDinero(int val) {
        this.dinero = val;
    }

    public String getNombre() {
        return nombre;
    }

    public void setNombre(String val) {
        this.nombre = val;
    }

    public void ComprarPropiedad() {
        
    }

    public void ComprarCasa() {
    }

    public boolean comprobarPropiedad(String nomProp) {
        return true;
    }

    public void cambiarPropiedad() {
    }

    public boolean getMonopolio() {
        if(monopolios[0]==2)
            return true;
        
        for(int i=1;i<7;i++)
            if(monopolios[i]==3)
                return true;
            
        if(monopolios[7]==2)
            return true;
        
        return false;
    }
    
    public int[]getColorMonopolio(){
        return monopolios;
    }

    public String getTipoFicha() {
        return TipoFicha;
    }

    public void setTipoFicha(String val) {
        this.TipoFicha = val;
    }


    public void Bancarrota() {
    }

    public int numEstaciones() {
        return 0;
    }

    public int numCompanias() {
        return 0;
    }

   public void pagarRentaA(int val) {
        dinero=dinero-val;
    }

    public void ComprarEstaciones() {
    }

    public void ComprarCompania() {
    }

    public void cobrarParking() {
    }
    
    
    public void setBancarrota(boolean val)
    {
        this.estaEnBancarrota=val;
    }
    
     public boolean getBancarrota()
    {
        return this.estaEnBancarrota;
    }

    public Long getId ()
    {
        return id;
    }

    public void setId (Long id)
    {
        this.id = id;
    }
/**
     * Returna un valor de cdigo hash para el objeto.  Esta implementacin computa
     * un valor de cdigo hash basado sobre los campos id en este objeto.
     * @return  un valor de cdigo hash para este objeto.
     */
    @Override
    public int hashCode() {
        int hash = 0;
        hash += (this.id != null ? this.id.hashCode() : 0);
        return hash;
    }

    /**
     * Determina si otro objeto es igual a este Jugador.  El resultado es  
     * <code>verdadero</code> s y slo s el argumento no es nulo y es unJugador objeto que tiene  valores idnticos en el campo id tal como este objeto.
     * @param objeto que referencia el objeto con el cual comparar @return <code>verdadero</code> si este objeto es idntico al argumento; de otra manera ser<code>falso</code>.
     */
    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Jugador)) {
            return false;
        }
        Jugador other = (Jugador)object;
        if (this.id != other.id && (this.id == null || !this.id.equals(other.id))) return false;
        return true;
    }

   
   
    
    
 
    

    
}
